<template lang="html">
  <div class="upload-app">
    <button class="collapsible-title-button"
      v-on:click="toggleExpanded()"
      v-bind:class="{ expanded: expanded, condensed: !expanded }">
      <span>{{ label.APP }}</span>
    </button>
    <div v-show="expanded" class="content">
      <div class="type-section">
        <label for="type" class="section-title">{{ label.APP_TYPE }}</label>
        <div class="filter-item">
          <select id="type"
            class="filter-item-select"
            v-model.trim="language">
            <option value="spa">{{ label.SINGLE_PAGE_APP }}</option>
            <!--<option value="node">{{ label.NODEJS }}</option>-->
          </select>
        </div>
        <div v-if="$v.language.$invalid" class="error">
          <span v-if="!$v.language.required">App Language is required.</span>
        </div>
        <div>
          {{ label.APP_TYPE_SPA_1 }}
          <button class="linkBtn"
            v-on:click="showMediaDialog()">{{ label.CONTAIN_INDEX_HTML }}</button>
          {{ label.APP_TYPE_SPA_2 }}
        </div>
      </div>
      <hr class="section-division">
      <div class="file-section">
        <label for="file" class="section-title">{{ label.GAME_FILE }}</label>
        <input id="file"
          ref="file"
          type="file"
          class="button"
          v-on:change="handleFileSelect($event)">
        <div v-if="$v.zipFile.$invalid" class="error">
          <span v-if="!$v.zipFile.required">Application zip file is required.</span>
        </div>
      </div>
      <div>{{ label.ZIP_INFO }}</div>
    </div>
  </div>
</template>

<script>
import { mapState, mapActions } from 'vuex'
import { required } from 'vuelidate/lib/validators'

export default {
  name: 'ep-upload-app',
  data () {
    return {
      language: 'spa',
      zipFile: null,
      zipFileType: '',
      expanded: true,
      label: {
        APP: 'GAME APP',
        APP_TYPE: 'Application Type',
        SINGLE_PAGE_APP: 'SPA - Single Page App',
        NODEJS: 'Node.js',
        SUPPORT_INFO: '* Support for Node.js, Java, Go, Python & Ruby is in progress.',
        APP_TYPE_SPA_1: '* SPA requires your app zip file',
        APP_TYPE_SPA_2: 'at the root.',
        CONTAIN_INDEX_HTML: 'contains index.html',
        GAME_FILE: 'Application Zip File',
        ZIP_INFO: '* A .zip file containing index.html'
      }
    }
  },
  validations: {
    language: {
      required
    },
    zipFile: {
      required
    }
  },
  watch: {
    zipFile () {
      if (this.zipFileType.match('application/zip')) {
        this.$emit('zip-file', this.zipFile)
      } else {
        this.$emit('zip-file', null)
      }
    },
    language () {
      this.$emit('language', this.language)
    }
  },
  computed: {
    ...mapState('app', [
      'dialogTypes'
    ])
  },
  methods: {
    ...mapActions('app', [
      'selectDialog'
    ]),
    handleFileSelect (event) {
      event.preventDefault()

      let files = event.target.files

      for (let i = 0; i < files.length; i++) {
        let f = files[i]

        this.zipFileType = f.type
        if (!f.type.match('application/zip')) {
          return
        }

        let reader = new window.FileReader()

        reader.onload = ((file) => {
          return (e) => {
            // this.zipFile = e.target.result
            this.zipFile = this.$refs.file.files[0]
          }
        })(f)

        reader.readAsDataURL(f)
      }
    },
    showMediaDialog () {
      this.selectDialog({
        dialog: this.dialogTypes.media,
        data: {
          type: 'image',
          source: 'https://res.cloudinary.com/enoplay-org/image/upload/q_auto:eco/v1493633500/upload_game_project_example_smtihr.png'
        }
      })
    },
    toggleExpanded () {
      this.expanded = !this.expanded
    }
  }
}
</script>

<style lang="scss" scoped>
@import '~assets/styles/input';
@import '~assets/styles/list';

.upload-app {
  display: block;
  position: relative;
  margin: 0;
  padding: 16px;
  border-right: none;
  border-left: none;
  border-bottom: 1px solid #dcdcdc;
}

.content {
  margin-top: 20px;
}

.section-division {
  margin: 24px 0;
  border: none;
  border-bottom: 1px solid $dark-gray;
}

.error {
  margin-bottom: 20px;
  color: #cc0000;

  &.signUpError {
    margin-top: 12px;
    margin-bottom: 0;
  }
}

</style>
